/*
    CustomViewer Class

    An OpenSceneGraph viewer for pyVolution .sww files.
    copyright (C) 2004-2005 Geoscience Australia
*/


#ifndef CUSTOMVIEWER_H
#define CUSTOMVIEWER_H


#include <project.h>
#include <osgProducer/Viewer>
#include "customtrackball.h"
#include "customterrainmanipulator.h"


class CustomViewer : public osgProducer::Viewer
{

public:
    CustomViewer(osg::ArgumentParser& arguments);
    void setUpViewer(unsigned int options=STANDARD_SETTINGS);
    virtual CustomTrackballManipulator* getTrackball(){return _trackball;}
    virtual CustomTerrainManipulator* getTerrainManipulator(){return _terrainmanipulator;}
    osg::Vec3d getPosition(){return osg::Vec3d(_position[0],_position[1],_position[2]);}
    osg::Quat getOrientation(){return _orientation;}
    //virtual void setPosition( osg::Vec3 position );
    //virtual void setOrientation( osg::Quat orientation );

protected:
    CustomTrackballManipulator* _trackball;
    CustomTerrainManipulator* _terrainmanipulator;

};

#endif  // CUSTOMVIEWER_H
